The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Twang Class Reference

STK enhanced plucked string class. More...

`#include <Twang.h>`

Inheritance diagram for stk::Twang:

## Public Member Functions
| Twang (StkFloat lowestFrequency=50.0)
| Class constructor, taking the lowest desired playing frequency.
void | clear (void)
| Reset and clear all internal state.
void | setLowestFrequency (StkFloat frequency)
| Set the delayline parameters to allow frequencies as low as specified.
void | setFrequency (StkFloat frequency)
| Set the delayline parameters for a particular frequency.
void | setPluckPosition (StkFloat position)
| Set the pluck or "excitation" position along the string (0.0 - 1.0).
void | setLoopGain (StkFloat loopGain)
| Set the nominal loop gain. More...
void | setLoopFilter (std::vector< StkFloat > coefficients)
| Set the loop filter coefficients. More...
StkFloat | lastOut (void)
| Return an StkFrames reference to the last output sample frame. More...
StkFloat | tick (StkFloat input)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK enhanced plucked string class.

This class implements an enhanced plucked-string physical model, a la Jaffe-Smith, Smith, Karjalainen and others. It includes a comb filter to simulate pluck position. The tick() function takes an input sample, which is added to the delayline input. This can be used to implement commuted synthesis (if the input samples are derived from the impulse response of a body filter) and/or feedback (as in an electric guitar model).

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

by Perry R. Cook and Gary P. Scavone, 1995–2019.

## Member Function Documentation

## ◆ setLoopGain()

void stk::Twang::setLoopGain | ( | StkFloat | loopGain | ) |

Set the nominal loop gain.

The actual loop gain is based on the value set with this function, but scaled slightly according to the frequency. Higher frequency settings have greater loop gains because of high-frequency loop-filter roll-off.

## ◆ setLoopFilter()

void stk::Twang::setLoopFilter | ( | std::vector< StkFloat > | coefficients | ) |

Set the loop filter coefficients.

The loop filter can be any arbitrary FIR filter. By default, the coefficients are set for a first-order lowpass filter with coefficients b = [0.5 0.5].

## ◆ lastOut()

StkFloat stk::Twang::lastOut | ( | void |  | ) |
| inline

Return an StkFrames reference to the last output sample frame.

Return the last computed output value.

74 { return lastOutput_; };

## ◆ tick() [1/2]

StkFrames & stk::Twang::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

123 {
124 #if defined(_STK_DEBUG_)
125 if ( channel >= frames.channels() ) {
126 oStream_ << "Twang::tick(): channel and StkFrames arguments are incompatible!";
127 handleError( StkError::FUNCTION_ARGUMENT );
128 }
129 #endif
130
131 StkFloat *samples = &frames[channel];
132 unsigned int hop = frames.channels();
133 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
134 *samples = tick( *samples );
135
136 return frames;
137 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Twang::tick
StkFloat tick(StkFloat input)
Compute and return one output sample.
Definition: Twang.h:113

## ◆ tick() [2/2]

StkFrames & stk::Twang::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

140 {
141 #if defined(_STK_DEBUG_)
142 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
143 oStream_ << "Twang::tick(): channel and StkFrames arguments are incompatible!";
144 handleError( StkError::FUNCTION_ARGUMENT );
145 }
146 #endif
147
148 StkFloat *iSamples = &iFrames[iChannel];
149 StkFloat *oSamples = &oFrames[oChannel];
150 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
151 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop )
152 *oSamples = tick( *iSamples );
153
154 return iFrames;
155 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Twang::tick
StkFloat tick(StkFloat input)
Compute and return one output sample.
Definition: Twang.h:113

The documentation for this class was generated from the following file:

- Twang.h

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.